﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using System.Collections;
using System.ComponentModel;

namespace MultiSelectListBindingProblem
{
    public class MyListBox : ListBox
    {
        public static  DependencyProperty NewLBSelectedItemsProperty = DependencyProperty.Register("NewLBSelectedItems", typeof(IEnumerable), typeof(MyListBox));


        public IEnumerable NewLBSelectedItems
        {
            get { return (IEnumerable)GetValue(NewLBSelectedItemsProperty); }
            set { SetValue(NewLBSelectedItemsProperty, value); } 
        }

        private void NewLBSelectedItemsPropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {

        }

        public MyListBox(): base()
        {
            NewLBSelectedItemsProperty.OverrideMetadata(typeof(MyDataGrid), new FrameworkPropertyMetadata(NewLBSelectedItemsPropertyChanged));
            this.SelectionChanged += new SelectionChangedEventHandler(MyListBox_SelectionChanged);
        }

        void MyListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //IEnumerable asd = (this.Items as IEnumerable);
            //var dfgfd = asd.OfType<ListBoxItem>();
            this.NewLBSelectedItems = null;
            this.NewLBSelectedItems = this.SelectedItems as IEnumerable;
        }
    }
}
